Index: palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- palm/trunk/SOURCE/salsa_mod.f90	(revision 3579)
+++ palm/trunk/SOURCE/salsa_mod.f90	(revision 3582)
@@ -11661,4 +10295,38 @@
     END SELECT
     
+    
+    IF ( .NOT. resorted )  THEN
+       IF ( .NOT. mask_surface(mid) )  THEN
+!
+!--       Default masked output    
+          DO  i = 1, mask_size_l(mid,1)
+             DO  j = 1, mask_size_l(mid,2)
+                DO  k = 1, mask_size_l(mid,3)
+                   local_pf(i,j,k) = to_be_resorted( mask_k(mid,k),            &
+                                                     mask_j(mid,j),mask_i(mid,i) )
+                ENDDO
+             ENDDO
+          ENDDO
+       ELSE
+!
+!--       Terrain-following masked output      
+          DO  i = 1, mask_size_l(mid,1)
+             DO  j = 1, mask_size_l(mid,2)
+!
+!--             Get k index of highest horizontal surface
+                topo_top_ind = get_topography_top_index_ji( mask_j(mid,j),     &
+                                                            mask_i(mid,i), grid )
+!
+!--             Save output array
+                DO  k = 1, mask_size_l(mid,3)
+                   local_pf(i,j,k) = to_be_resorted( MIN( topo_top_ind+mask_k(mid,k),&
+                                                          nzt+1 ),             &
+                                                     mask_j(mid,j), mask_i(mid,i) )
+                ENDDO
+             ENDDO
+          ENDDO
+       ENDIF
+    ENDIF
+    
  END SUBROUTINE salsa_data_output_mask
  
Index: palm/trunk/SOURCE/sum_up_3d_data.f90
===================================================================
--- palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 3579)
+++ palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 3582)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! ------------------
-! 
+! Move the control parameter "salsa" from salsa_mod to control_parameters 
+! (M. Kurppa)
 ! 
 ! Former revisions:
@@ -122,5 +123,5 @@
 ! - Workaround for sum-up usm arrays in case of restart runs, to avoid program 
 !   crash (MS)
-! 
+!
 ! 2292 2017-06-20 09:51:42Z schwenkel
 ! Implementation of new microphysic scheme: cloud_scheme = 'morrison' 
@@ -263,5 +264,5 @@
     USE control_parameters,                                                    &
         ONLY:  air_chemistry, average_count_3d, biometeorology, doav, doav_n,  &
-               land_surface, ocean_mode, rho_surface, urban_surface,           &
+               land_surface, ocean_mode, rho_surface, salsa, urban_surface,    &
                varnamelength
 
@@ -290,5 +291,5 @@
          
     USE salsa_mod,                                                             &
-        ONLY:  salsa, salsa_3d_data_averaging          
+        ONLY:  salsa_3d_data_averaging          
 
     USE surface_mod,                                                           &
@@ -552,7 +553,5 @@
                    CALL radiation_3d_data_averaging( 'allocate', doav(ii) )
                 ENDIF
-                
-!
-!--             SALSA quantity
+
                 IF ( salsa )  THEN
                    CALL salsa_3d_data_averaging( 'allocate', doav(ii) )
@@ -1202,7 +1201,5 @@
                 CALL radiation_3d_data_averaging( 'sum', doav(ii) )
              ENDIF
-             
-!
-!--          SALSA quantity
+
              IF ( salsa )  THEN
                 CALL salsa_3d_data_averaging( 'sum', doav(ii) )
Index: palm/trunk/SOURCE/swap_timelevel.f90
===================================================================
--- palm/trunk/SOURCE/swap_timelevel.f90	(revision 3579)
+++ palm/trunk/SOURCE/swap_timelevel.f90	(revision 3582)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! Move the control parameter "salsa" from salsa_mod to control_parameters 
+! (M. Kurppa)
 ! 
 ! Former revisions:
@@ -162,5 +163,5 @@
         ONLY:  air_chemistry, humidity, land_surface, neutral, ocean_mode,     &
                passive_scalar, simulated_time, timestep_count, urban_surface,  &
-               time_since_reference_point
+               time_since_reference_point, salsa
 
     USE gust_mod,                                                              &
@@ -182,5 +183,5 @@
          
     USE salsa_mod,                                                             &
-        ONLY:  salsa, salsa_swap_timelevel, skip_time_do_salsa             
+        ONLY:  salsa_swap_timelevel, skip_time_do_salsa             
 
     USE turbulence_closure_mod,                                                &
@@ -295,5 +296,5 @@
     IF ( salsa  .AND.  simulated_time >= time_since_reference_point )  THEN
        CALL salsa_swap_timelevel(  MOD( timestep_count, 2 ) )
-    ENDIF  
+    ENDIF     
 
     CALL tcm_swap_timelevel( MOD( timestep_count, 2) )
Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 3579)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 3582)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! ------------------
-! 
+! Move the control parameter "salsa" from salsa_mod to control_parameters 
+! (M. Kurppa)
 ! 
 ! Former revisions:
@@ -460,5 +461,6 @@
                ocean_mode, passive_scalar, pt_reference,                       &
                pt_slope_offset, random_heatflux, rans_mode,                    &
-               rans_tke_e, run_coupled, simulated_time, simulated_time_chr,    &
+               rans_tke_e, run_coupled, salsa,                                 &
+               simulated_time, simulated_time_chr,                             &
                skip_time_do2d_xy, skip_time_do2d_xz, skip_time_do2d_yz,        &
                skip_time_do3d, skip_time_domask, skip_time_dopr,               &
@@ -475,5 +477,5 @@
                use_single_reference_value, u_gtrans, v_gtrans,                 &
                virtual_flight, virtual_measurement, wind_turbine,              &
-               ws_scheme_mom, ws_scheme_sca
+               ws_scheme_mom, ws_scheme_sca 
 
     USE cpulog,                                                                &
@@ -542,4 +544,9 @@
               radiation_interaction, radiation_interactions,                   &
               skip_time_do_radiation, time_radiation
+         
+    USE salsa_mod,                                                             &
+        ONLY: aerosol_number, aerosol_mass, nbins, ncc_tot, ngast,             &
+              salsa_boundary_conds, salsa_gas, salsa_gases_from_chem,          &
+              skip_time_do_salsa                      
 
     USE spectra_mod,                                                           &
@@ -574,10 +581,5 @@
         ONLY:  dt_stg_call, dt_stg_adjust, parametrize_inflow_turbulence,      &
                stg_adjust, stg_main, time_stg_adjust, time_stg_call,           &
-               use_syn_turb_gen
-         
-    USE salsa_mod,                                                             &
-        ONLY: aerosol_number, aerosol_mass, nbins, ncc_tot, ngast, salsa,      &
-              salsa_boundary_conds, salsa_gas, salsa_gases_from_chem,          &
-              skip_time_do_salsa           
+               use_syn_turb_gen   
 
     USE user_actions_mod,                                                      &
@@ -916,5 +918,4 @@
              CALL cpu_log( log_point_s(91), 'salsa exch-horiz ', 'stop' )
           ENDIF         
-
           CALL cpu_log( log_point(26), 'exchange-horiz-progn', 'stop' )
 
Index: palm/trunk/SOURCE/write_restart_data_mod.f90
===================================================================
--- palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 3579)
+++ palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 3582)
@@ -20,4 +20,6 @@
 ! Current revisions:
 ! -----------------
+! Move the control parameter "salsa" from salsa_mod to control_parameters 
+! (M. Kurppa)
 ! 
 ! 
@@ -945,5 +947,5 @@
               
        USE salsa_mod,                                                          &
-           ONLY:  salsa, salsa_wrd_local          
+           ONLY:  salsa_wrd_local          
 
        USE surface_mod,                                                        &
@@ -1273,7 +1275,7 @@
        IF ( land_surface )         CALL lsm_wrd_local
        IF ( ocean_mode )           CALL ocean_wrd_local
-       CALL surface_wrd_local
        IF ( radiation )            CALL radiation_wrd_local
        IF ( salsa )                CALL salsa_wrd_local
+       CALL surface_wrd_local
        IF ( urban_surface )        CALL usm_wrd_local
 
